<template>
  <header
    class="group/drag-button relative flex flex-nowrap items-center justify-between gap-3 pb-2"
  >
    <slot />
    <TextField
      :id="id"
      ref="target"
      v-model="title"
      class="text-2xl text-slate-800"
      @keydown="tryRemoveListOrCreateTaskByKey"
      @blur="tryRemoveTaskIfValueEmpty"
    />
    <TaskMenu :task="list" />
  </header>
</template>

<script lang="ts" setup>
import {
  type ITask,
  useTaskFocus,
  useTryRemoveEmptyTask,
} from '~entities/tasks';
import { TextField } from '~shared/ui';
import { useTasksStore } from '~/stores/tasks';
import { TaskMenu } from '~/features/tasks';

const props = defineProps<{
  list: ITask;
}>();
const { id, title } = toRefs(props.list);
const store = useTasksStore();
const target = ref();
useTaskFocus(id, target);
const { tryRemoveTaskIfValueEmpty } = useTryRemoveEmptyTask(id);

watch([title], ([title]) => {
  store.updateTask({ ...props.list, title });
});

const tryRemoveListOrCreateTaskByKey = (e: KeyboardEvent) => {
  if (e.key === 'Backspace') {
    tryRemoveTaskIfValueEmpty(e);
  } else if (e.key === 'Enter') {
    e.preventDefault();
    store.addTask({ parent: id.value } as ITask);
  }
};
</script>
